/[gentoo-x86]/eclass/mysql.eclass
Gentoo

Diff of /eclass/mysql.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.118 Revision 1.163
1# Copyright 1999-2007 Gentoo Foundation 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.118 2009/11/19 20:59:38 hanno Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.163 2011/08/21 16:14:56 jmbsvicetto Exp $
4 4
5# @ECLASS: mysql.eclass
6# @MAINTAINER:
5# Author: Francesco Riosa (Retired) <vivo@gentoo.org> 7# Author: Francesco Riosa (Retired) <vivo@gentoo.org>
6# Maintainer: MySQL Team <mysql-bugs@gentoo.org> 8# Maintainers: MySQL Team <mysql-bugs@gentoo.org>
7# - Luca Longinotti <chtekk@gentoo.org> 9# - Luca Longinotti <chtekk@gentoo.org>
8# - Robin H. Johnson <robbat2@gentoo.org> 10# - Robin H. Johnson <robbat2@gentoo.org>
11# @BLURB: This eclass provides most of the functions for mysql ebuilds
12# @DESCRIPTION:
13# The mysql.eclass provides almost all the code to build the mysql ebuilds
14# including the src_unpack, src_prepare, src_configure, src_compile,
15# scr_install, pkg_preinst, pkg_postinst, pkg_config and pkg_postrm
16# phase hooks.
9 17
10WANT_AUTOCONF="latest" 18WANT_AUTOCONF="latest"
11WANT_AUTOMAKE="latest" 19WANT_AUTOMAKE="latest"
12 20
13inherit eutils flag-o-matic gnuconfig autotools mysql_fx versionator 21inherit eutils flag-o-matic gnuconfig autotools mysql_fx versionator toolchain-funcs
22
23# Shorten the path because the socket path length must be shorter than 107 chars
24# and we will run a mysql server during test phase
25S="${WORKDIR}/mysql"
26
27[[ "${MY_EXTRAS_VER}" == "latest" ]] && MY_EXTRAS_VER="20090228-0714Z"
28if [[ "${MY_EXTRAS_VER}" == "live" ]]; then
29 EGIT_PROJECT=mysql-extras
30 EGIT_REPO_URI="git://git.overlays.gentoo.org/proj/mysql-extras.git"
31 inherit git
32fi
14 33
15case "${EAPI:-0}" in 34case "${EAPI:-0}" in
16 2) 35 2)
17 EXPORT_FUNCTIONS pkg_setup \ 36 EXPORT_FUNCTIONS pkg_setup \
18 src_unpack src_prepare \ 37 src_unpack src_prepare \
20 src_install \ 39 src_install \
21 pkg_preinst pkg_postinst \ 40 pkg_preinst pkg_postinst \
22 pkg_config pkg_postrm 41 pkg_config pkg_postrm
23 IUSE_DEFAULT_ON='+' 42 IUSE_DEFAULT_ON='+'
24 ;; 43 ;;
25 *) 44 0 | 1)
26 EXPORT_FUNCTIONS pkg_setup \ 45 EXPORT_FUNCTIONS pkg_setup \
27 src_unpack \ 46 src_unpack \
28 src_compile \ 47 src_compile \
29 src_install \ 48 src_install \
30 pkg_preinst pkg_postinst \ 49 pkg_preinst pkg_postinst \
31 pkg_config pkg_postrm 50 pkg_config pkg_postrm
32 ;; 51 ;;
52 *)
53 die "Unsupported EAPI: ${EAPI}" ;;
33esac 54esac
34 55
35# Shorten the path because the socket path length must be shorter than 107 chars
36# and we will run a mysql server during test phase
37S="${WORKDIR}/mysql"
38 56
39[[ "${MY_EXTRAS_VER}" == "latest" ]] && MY_EXTRAS_VER="20090228-0714Z" 57# @ECLASS-VARIABLE: MYSQL_PV_MAJOR
40if [[ "${MY_EXTRAS_VER}" == "live" ]]; then 58# @DESCRIPTION:
41 EGIT_PROJECT=mysql-extras 59# Upstream MySQL considers the first two parts of the version number to be the
42 EGIT_REPO_URI="git://git.overlays.gentoo.org/proj/mysql-extras.git" 60# major version. Upgrades that change major version should always run
43 inherit git 61# mysql_upgrade.
62MYSQL_PV_MAJOR="$(get_version_component_range 1-2 ${PV})"
63
64# Cluster is a special case...
65if [[ "${PN}" == "mysql-cluster" ]]; then
66 case $PV in
67 6.1*|7.0*|7.1*) MYSQL_PV_MAJOR=5.1 ;;
68 esac
44fi 69fi
45 70
71
72# @ECLASS-VARIABLE: MYSQL_VERSION_ID
73# @DESCRIPTION:
46# MYSQL_VERSION_ID will be: 74# MYSQL_VERSION_ID will be:
47# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99] 75# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99]
48# This is an important part, because many of the choices the MySQL ebuild will do 76# This is an important part, because many of the choices the MySQL ebuild will do
49# depend on this variable. 77# depend on this variable.
50# In particular, the code below transforms a $PVR like "5.0.18-r3" in "5001803" 78# In particular, the code below transforms a $PVR like "5.0.18-r3" in "5001803"
59 MYSQL_VERSION_ID="${MYSQL_VERSION_ID}${tpv[${vatom}]:0-2}" 87 MYSQL_VERSION_ID="${MYSQL_VERSION_ID}${tpv[${vatom}]:0-2}"
60done 88done
61# strip leading "0" (otherwise it's considered an octal number by BASH) 89# strip leading "0" (otherwise it's considered an octal number by BASH)
62MYSQL_VERSION_ID=${MYSQL_VERSION_ID##"0"} 90MYSQL_VERSION_ID=${MYSQL_VERSION_ID##"0"}
63 91
92# @ECLASS-VARIABLE: MYSQL_COMMUNITY_FEATURES
93# @DESCRIPTION:
94# Specifiy if community features are available. Possible values are 1 (yes)
95# and 0 (no).
64# Community features are available in mysql-community 96# Community features are available in mysql-community
65# AND in the re-merged mysql-5.0.82 and newer 97# AND in the re-merged mysql-5.0.82 and newer
66if [ "${PN}" == "mysql-community" ]; then 98if [ "${PN}" == "mysql-community" -o "${PN}" == "mariadb" ]; then
67 MYSQL_COMMUNITY_FEATURES=1 99 MYSQL_COMMUNITY_FEATURES=1
68elif [ "${PV#5.0}" != "${PV}" ] && mysql_version_is_at_least "5.0.82"; then 100elif [ "${PV#5.0}" != "${PV}" ] && mysql_version_is_at_least "5.0.82"; then
69 MYSQL_COMMUNITY_FEATURES=1 101 MYSQL_COMMUNITY_FEATURES=1
70elif [ "${PV#5.1}" != "${PV}" ] && mysql_version_is_at_least "5.1.28"; then 102elif [ "${PV#5.1}" != "${PV}" ] && mysql_version_is_at_least "5.1.28"; then
71 MYSQL_COMMUNITY_FEATURES=1 103 MYSQL_COMMUNITY_FEATURES=1
72elif [ "${PV#5.4}" != "${PV}" ]; then 104elif [ "${PV#5.4}" != "${PV}" ] ; then
105 MYSQL_COMMUNITY_FEATURES=1
106elif [ "${PV#5.5}" != "${PV}" ] ; then
107 MYSQL_COMMUNITY_FEATURES=1
108elif [ "${PV#6}" != "${PV}" ] ; then
109 MYSQL_COMMUNITY_FEATURES=1
110elif [ "${PV#7}" != "${PV}" ] ; then
73 MYSQL_COMMUNITY_FEATURES=1 111 MYSQL_COMMUNITY_FEATURES=1
74else 112else
75 MYSQL_COMMUNITY_FEATURES=0 113 MYSQL_COMMUNITY_FEATURES=0
76fi 114fi
115
116# @ECLASS-VARIABLE: XTRADB_VER
117# @DESCRIPTION:
118# Version of the XTRADB storage engine
119XTRADB_VER="${XTRADB_VER}"
120
121# @ECLASS-VARIABLE: PERCONA_VER
122# @DESCRIPTION:
123# Designation by PERCONA for a MySQL version to apply an XTRADB release
124PERCONA_VER="${PERCONA_VER}"
77 125
78# Be warned, *DEPEND are version-dependant 126# Be warned, *DEPEND are version-dependant
79# These are used for both runtime and compiletime 127# These are used for both runtime and compiletime
80DEPEND="ssl? ( >=dev-libs/openssl-0.9.6d ) 128DEPEND="ssl? ( >=dev-libs/openssl-0.9.6d )
81 userland_GNU? ( sys-process/procps ) 129 userland_GNU? ( sys-process/procps )
82 >=sys-apps/sed-4 130 >=sys-apps/sed-4
83 >=sys-apps/texinfo-4.7-r1 131 >=sys-apps/texinfo-4.7-r1
84 >=sys-libs/readline-4.1 132 >=sys-libs/readline-4.1
85 >=sys-libs/zlib-1.2.3" 133 >=sys-libs/zlib-1.2.3"
86 134
135[[ "${PN}" == "mariadb" ]] \
136&& DEPEND="${DEPEND} libevent? ( >=dev-libs/libevent-1.4 )"
137
87# Having different flavours at the same time is not a good idea 138# Having different flavours at the same time is not a good idea
88for i in "" "-community" ; do 139for i in "mysql" "mysql-community" "mysql-cluster" "mariadb" ; do
89 [[ "${i}" == ${PN#mysql} ]] || 140 [[ "${i}" == ${PN} ]] ||
90 DEPEND="${DEPEND} !dev-db/mysql${i}" 141 DEPEND="${DEPEND} !dev-db/${i}"
91done 142done
92 143
93RDEPEND="${DEPEND} 144RDEPEND="${DEPEND}
94 !minimal? ( dev-db/mysql-init-scripts ) 145 !minimal? ( dev-db/mysql-init-scripts )
95 selinux? ( sec-policy/selinux-mysql )" 146 selinux? ( sec-policy/selinux-mysql )"
96 147
148DEPEND="${DEPEND}
149 virtual/yacc"
150
151if [ "${EAPI:-0}" = "2" ]; then
152 DEPEND="${DEPEND} static? ( || ( sys-libs/ncurses[static-libs] <=sys-libs/ncurses-5.7-r3 ) )"
153fi
154
97# compile-time-only 155# compile-time-only
98mysql_version_is_at_least "5.1" \ 156mysql_version_is_at_least "5.1" \
99|| DEPEND="${DEPEND} berkdb? ( sys-apps/ed )" 157|| DEPEND="${DEPEND} berkdb? ( sys-apps/ed )"
100 158
101# compile-time-only 159# compile-time-only
102mysql_version_is_at_least "5.1.12" \ 160mysql_version_is_at_least "5.1.12" \
103&& DEPEND="${DEPEND} >=dev-util/cmake-2.4.3" 161&& DEPEND="${DEPEND} >=dev-util/cmake-2.4.3"
104 162
163[[ "${PN}" == "mariadb" ]] \
164&& mysql_version_is_at_least "5.2" \
165&& DEPEND="${DEPEND} oqgraph? ( >=dev-libs/boost-1.40.0 )"
166#SphinxSE is included but is not available in 5.2.4 due to a missing plug.in file
167# sphinx? ( app-misc/sphinx )"
168
105# dev-perl/DBD-mysql is needed by some scripts installed by MySQL 169# dev-perl/DBD-mysql is needed by some scripts installed by MySQL
106PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )" 170PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )"
107 171
108# For other stuff to bring us in 172# For other stuff to bring us in
109PDEPEND="${PDEPEND} =virtual/mysql-$(get_version_component_range 1-2 ${PV})" 173PDEPEND="${PDEPEND} =virtual/mysql-${MYSQL_PV_MAJOR}"
110 174
111# Work out the default SERVER_URI correctly 175# Work out the default SERVER_URI correctly
112if [ -z "${SERVER_URI}" ]; then 176if [ -z "${SERVER_URI}" ]; then
177 [ -z "${MY_PV}" ] && MY_PV="${PV//_/-}"
178 if [ "${PN}" == "mariadb" ]; then
179 MARIA_FULL_PV="$(replace_version_separator 3 '-' ${PV})"
180 MARIA_FULL_P="${PN}-${MARIA_FULL_PV}"
181 SERVER_URI="
182 http://ftp.osuosl.org/pub/mariadb/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
183 http://ftp.rediris.es/mirror/MariaDB/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
184 http://maria.llarian.net/download/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
185 http://launchpad.net/maria/${MYSQL_PV_MAJOR}/ongoing/+download/${MARIA_FULL_P}.tar.gz
186 http://mirrors.fe.up.pt/pub/${PN}/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
187 http://ftp-stud.hs-esslingen.de/pub/Mirrors/${PN}/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
188 "
113 # The community build is on the mirrors 189 # The community and cluster builds are on the mirrors
114 if [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then 190 elif [[ "${MYSQL_COMMUNITY_FEATURES}" == "1" || ${PN} == "mysql-cluster" ]] ; then
115 SERVER_URI="mirror://mysql/Downloads/MySQL-${PV%.*}/mysql-${PV//_/-}.tar.gz" 191 if [[ "${PN}" == "mysql-cluster" ]] ; then
192 URI_DIR="MySQL-Cluster"
193 URI_FILE="mysql-cluster-gpl"
194 else
195 URI_DIR="MySQL"
196 URI_FILE="mysql"
197 fi
198 URI_A="${URI_FILE}-${MY_PV}.tar.gz"
199 MIRROR_PV=$(get_version_component_range 1-2 ${PV})
200 # Recently upstream switched to an archive site, and not on mirrors
201 SERVER_URI="http://downloads.mysql.com/archives/${URI_FILE}-${MIRROR_PV}/${URI_A}
202 mirror://mysql/Downloads/${URI_DIR}-${PV%.*}/${URI_A}"
116 # The (old) enterprise source is on the primary site only 203 # The (old) enterprise source is on the primary site only
117 elif [ "${PN}" == "mysql" ]; then 204 elif [ "${PN}" == "mysql" ]; then
118 SERVER_URI="ftp://ftp.mysql.com/pub/mysql/src/mysql-${PV//_/-}.tar.gz" 205 SERVER_URI="ftp://ftp.mysql.com/pub/mysql/src/mysql-${MY_PV}.tar.gz"
119 fi 206 fi
120fi 207fi
121 208
122# Define correct SRC_URIs 209# Define correct SRC_URIs
123SRC_URI="${SERVER_URI}" 210SRC_URI="${SERVER_URI}"
124 211
125[[ ${MY_EXTRAS_VER} != live ]] && SRC_URI="${SRC_URI} 212# Gentoo patches to MySQL
213[[ ${MY_EXTRAS_VER} != live ]] \
214&& SRC_URI="${SRC_URI}
126 mirror://gentoo/mysql-extras-${MY_EXTRAS_VER}.tar.bz2 215 mirror://gentoo/mysql-extras-${MY_EXTRAS_VER}.tar.bz2
127 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2" 216 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2
128mysql_version_is_at_least "5.1.12" \ 217 http://dev.gentoo.org/~robbat2/distfiles/mysql-extras-${MY_EXTRAS_VER}.tar.bz2"
129&& [[ -n "${PBXT_VERSION}" ]] \
130&& SRC_URI="${SRC_URI} pbxt? ( mirror://sourceforge/pbxt/pbxt-${PBXT_VERSION}.tar.gz )"
131 218
132DESCRIPTION="A fast, multi-threaded, multi-user SQL database server." 219DESCRIPTION="A fast, multi-threaded, multi-user SQL database server."
133HOMEPAGE="http://www.mysql.com/" 220HOMEPAGE="http://www.mysql.com/"
221if [[ "${PN}" == "mariadb" ]]; then
222 HOMEPAGE="http://askmonty.org/"
223 DESCRIPTION="MariaDB is a MySQL fork with 3rd-party patches and additional storage engines merged."
224fi
225if [[ "${PN}" == "mysql-community" ]]; then
226 DESCRIPTION="${DESCRIPTION} (obsolete, move to dev-db/mysql)"
227fi
134LICENSE="GPL-2" 228LICENSE="GPL-2"
135SLOT="0" 229SLOT="0"
136IUSE="big-tables debug embedded minimal ${IUSE_DEFAULT_ON}perl selinux ssl static" 230IUSE="big-tables debug embedded minimal ${IUSE_DEFAULT_ON}perl selinux ssl static test"
137 231
138mysql_version_is_at_least "4.1" \ 232mysql_version_is_at_least "4.1" \
139&& IUSE="${IUSE} latin1" 233&& IUSE="${IUSE} latin1"
140 234
141mysql_version_is_at_least "4.1.3" \ 235if mysql_version_is_at_least "4.1.3" ; then
142&& IUSE="${IUSE} cluster extraengine" 236 IUSE="${IUSE} extraengine"
237 if [[ "${PN}" != "mysql-cluster" ]] ; then
238 IUSE="${IUSE} cluster"
239 fi
240fi
143 241
144mysql_version_is_at_least "5.0" \ 242mysql_version_is_at_least "5.0" \
145|| IUSE="${IUSE} raid" 243|| IUSE="${IUSE} raid"
146 244
147mysql_version_is_at_least "5.0.18" \ 245mysql_version_is_at_least "5.0.18" \
148&& IUSE="${IUSE} max-idx-128" 246&& IUSE="${IUSE} max-idx-128"
149 247
150mysql_version_is_at_least "5.1" \ 248mysql_version_is_at_least "5.1" \
151|| IUSE="${IUSE} berkdb" 249|| IUSE="${IUSE} berkdb"
152 250
153mysql_version_is_at_least "5.1.12" \
154&& IUSE="${IUSE} pbxt"
155
156[ "${MYSQL_COMMUNITY_FEATURES}" == "1" ] \ 251[ "${MYSQL_COMMUNITY_FEATURES}" == "1" ] \
157&& IUSE="${IUSE} ${IUSE_DEFAULT_ON}community profiling" 252&& IUSE="${IUSE} ${IUSE_DEFAULT_ON}community profiling"
253
254[[ "${PN}" == "mariadb" ]] \
255&& IUSE="${IUSE} libevent"
256
257[[ "${PN}" == "mariadb" ]] \
258&& mysql_version_is_at_least "5.2" \
259&& IUSE="${IUSE} oqgraph"
260#SphinxSE is included but is not available in 5.2.4 due to a missing plug.in file
261#&& IUSE="${IUSE} oqgraph sphinx"
262
263# MariaDB has integrated PBXT
264# PBXT_VERSION means that we have a PBXT patch for this PV
265# PBXT was only introduced after 5.1.12
266pbxt_patch_available() {
267 [[ "${PN}" != "mariadb" ]] \
268 && mysql_version_is_at_least "5.1.12" \
269 && [[ -n "${PBXT_VERSION}" ]]
270 return $?
271}
272
273pbxt_available() {
274 pbxt_patch_available || [[ "${PN}" == "mariadb" ]]
275 return $?
276}
277
278# Get the percona tarball if XTRADB_VER and PERCONA_VER are both set
279# MariaDB has integrated XtraDB
280# XTRADB_VERS means that we have a XTRADB patch for this PV
281# XTRADB was only introduced after 5.1.26
282xtradb_patch_available() {
283 [[ "${PN}" != "mariadb" ]] \
284 && mysql_version_is_at_least "5.1.26" \
285 && [[ -n "${XTRADB_VER}" && -n "${PERCONA_VER}" ]]
286 return $?
287}
288
289
290pbxt_patch_available \
291&& PBXT_P="pbxt-${PBXT_VERSION}" \
292&& PBXT_SRC_URI="http://www.primebase.org/download/${PBXT_P}.tar.gz mirror://sourceforge/pbxt/${PBXT_P}.tar.gz" \
293&& SRC_URI="${SRC_URI} pbxt? ( ${PBXT_SRC_URI} )" \
294
295# PBXT_NEWSTYLE means pbxt is in storage/ and gets enabled as other plugins
296# vs. built outside the dir
297pbxt_available \
298&& IUSE="${IUSE} pbxt" \
299&& mysql_version_is_at_least "5.1.40" \
300&& PBXT_NEWSTYLE=1
301
302xtradb_patch_available \
303&& XTRADB_P="percona-xtradb-${XTRADB_VER}" \
304&& XTRADB_SRC_URI_COMMON="${PERCONA_VER}/source/${XTRADB_P}.tar.gz" \
305&& XTRADB_SRC_B1="http://www.percona.com/" \
306&& XTRADB_SRC_B2="${XTRADB_SRC_B1}/percona-builds/" \
307&& XTRADB_SRC_URI1="${XTRADB_SRC_B2}/Percona-Server/Percona-Server-${XTRADB_SRC_URI_COMMON}" \
308&& XTRADB_SRC_URI2="${XTRADB_SRC_B2}/xtradb/${XTRADB_SRC_URI_COMMON}" \
309&& XTRADB_SRC_URI3="${XTRADB_SRC_B1}/${PN}/xtradb/${XTRADB_SRC_URI_COMMON}" \
310&& SRC_URI="${SRC_URI} xtradb? ( ${XTRADB_SRC_URI1} ${XTRADB_SRC_URI2} ${XTRADB_SRC_URI3} )" \
311&& IUSE="${IUSE} xtradb"
158 312
159# 313#
160# HELPER FUNCTIONS: 314# HELPER FUNCTIONS:
161# 315#
162 316
317# @FUNCTION: mysql_disable_test
318# @DESCRIPTION:
319# Helper function to disable specific tests.
163mysql_disable_test() { 320mysql_disable_test() {
321 local rawtestname testname testsuite reason mysql_disable_file
164 local testname="${1}" ; shift 322 rawtestname="${1}" ; shift
165 local reason="${@}" 323 reason="${@}"
324 ewarn "test '${rawtestname}' disabled: '${reason}'"
325
326 testsuite="${rawtestname/.*}"
327 testname="${rawtestname/*.}"
166 local mysql_disable_file="${S}/mysql-test/t/disabled.def" 328 mysql_disable_file="${S}/mysql-test/t/disabled.def"
329 #einfo "rawtestname=${rawtestname} testname=${testname} testsuite=${testsuite}"
167 echo ${testname} : ${reason} >> "${mysql_disable_file}" 330 echo ${testname} : ${reason} >> "${mysql_disable_file}"
168 ewarn "test '${testname}' disabled: '${reason}'"
169}
170 331
332 # ${S}/mysql-tests/t/disabled.def
333 #
334 # ${S}/mysql-tests/suite/federated/disabled.def
335 #
336 # ${S}/mysql-tests/suite/jp/t/disabled.def
337 # ${S}/mysql-tests/suite/ndb/t/disabled.def
338 # ${S}/mysql-tests/suite/rpl/t/disabled.def
339 # ${S}/mysql-tests/suite/parts/t/disabled.def
340 # ${S}/mysql-tests/suite/rpl_ndb/t/disabled.def
341 # ${S}/mysql-tests/suite/ndb_team/t/disabled.def
342 # ${S}/mysql-tests/suite/binlog/t/disabled.def
343 # ${S}/mysql-tests/suite/innodb/t/disabled.def
344 if [ -n "${testsuite}" ]; then
345 for mysql_disable_file in \
346 ${S}/mysql-test/suite/${testsuite}/disabled.def \
347 ${S}/mysql-test/suite/${testsuite}/t/disabled.def \
348 FAILED ; do
349 [ -f "${mysql_disable_file}" ] && break
350 done
351 if [ "${mysql_disabled_file}" != "FAILED" ]; then
352 echo "${testname} : ${reason}" >> "${mysql_disable_file}"
353 else
354 ewarn "Could not find testsuite disabled.def location for ${rawtestname}"
355 fi
356 fi
357}
358
359# @FUNCTION: mysql_init_vars
360# @DESCRIPTION:
171# void mysql_init_vars() 361# void mysql_init_vars()
172#
173# Initialize global variables 362# Initialize global variables
174# 2005-11-19 <vivo@gentoo.org> 363# 2005-11-19 <vivo@gentoo.org>
175
176mysql_init_vars() { 364mysql_init_vars() {
177 MY_SHAREDSTATEDIR=${MY_SHAREDSTATEDIR="/usr/share/mysql"} 365 MY_SHAREDSTATEDIR=${MY_SHAREDSTATEDIR="/usr/share/mysql"}
178 MY_SYSCONFDIR=${MY_SYSCONFDIR="/etc/mysql"} 366 MY_SYSCONFDIR=${MY_SYSCONFDIR="/etc/mysql"}
179 MY_LIBDIR=${MY_LIBDIR="/usr/$(get_libdir)/mysql"} 367 MY_LIBDIR=${MY_LIBDIR="/usr/$(get_libdir)/mysql"}
180 MY_LOCALSTATEDIR=${MY_LOCALSTATEDIR="/var/lib/mysql"} 368 MY_LOCALSTATEDIR=${MY_LOCALSTATEDIR="/var/lib/mysql"}
224 MY_DATADIR="${new_MY_DATADIR}" 412 MY_DATADIR="${new_MY_DATADIR}"
225 fi 413 fi
226 fi 414 fi
227 fi 415 fi
228 416
417 if [ "${MY_SOURCEDIR:-unset}" == "unset" ]; then
229 MY_SOURCEDIR=${SERVER_URI##*/} 418 MY_SOURCEDIR=${SERVER_URI##*/}
230 MY_SOURCEDIR=${MY_SOURCEDIR%.tar*} 419 MY_SOURCEDIR=${MY_SOURCEDIR%.tar*}
420 fi
231 421
232 export MY_SHAREDSTATEDIR MY_SYSCONFDIR 422 export MY_SHAREDSTATEDIR MY_SYSCONFDIR
233 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR 423 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR
234 export MY_INCLUDEDIR MY_DATADIR MY_SOURCEDIR 424 export MY_INCLUDEDIR MY_DATADIR MY_SOURCEDIR
235} 425}
282 if use debug ; then 472 if use debug ; then
283 myconf="${myconf} --with-debug=full" 473 myconf="${myconf} --with-debug=full"
284 else 474 else
285 myconf="${myconf} --without-debug" 475 myconf="${myconf} --without-debug"
286 mysql_version_is_at_least "4.1.3" \ 476 mysql_version_is_at_least "4.1.3" \
287 && use cluster \ 477 && ( use cluster || [[ "${PN}" == "mysql-cluster" ]] ) \
288 && myconf="${myconf} --without-ndb-debug" 478 && myconf="${myconf} --without-ndb-debug"
289 fi 479 fi
290 480
291 if [ -n "${MYSQL_DEFAULT_CHARSET}" -a -n "${MYSQL_DEFAULT_COLLATION}" ]; then 481 if [ -n "${MYSQL_DEFAULT_CHARSET}" -a -n "${MYSQL_DEFAULT_COLLATION}" ]; then
292 ewarn "You are using a custom charset of ${MYSQL_DEFAULT_CHARSET}" 482 ewarn "You are using a custom charset of ${MYSQL_DEFAULT_CHARSET}"
316 myconf="${myconf} $(use_with perl bench)" 506 myconf="${myconf} $(use_with perl bench)"
317 myconf="${myconf} --enable-assembler" 507 myconf="${myconf} --enable-assembler"
318 myconf="${myconf} --with-extra-tools" 508 myconf="${myconf} --with-extra-tools"
319 myconf="${myconf} --with-innodb" 509 myconf="${myconf} --with-innodb"
320 myconf="${myconf} --without-readline" 510 myconf="${myconf} --without-readline"
511 myconf="${myconf} $(use_with ssl openssl)"
321 mysql_version_is_at_least "5.0" || myconf="${myconf} $(use_with raid)" 512 mysql_version_is_at_least "5.0" || myconf="${myconf} $(use_with raid)"
322 513
323 # --with-vio is not needed anymore, it's on by default and 514 # --with-vio is not needed anymore, it's on by default and
324 # has been removed from configure 515 # has been removed from configure
516 # Apply to 4.x and 5.0.[0-3]
325 if use ssl ; then 517 if use ssl ; then
326 mysql_version_is_at_least "5.0.4" || myconf="${myconf} --with-vio" 518 mysql_version_is_at_least "5.0.4" || myconf="${myconf} --with-vio"
327 fi
328
329 if mysql_version_is_at_least "5.1.11" ; then
330 myconf="${myconf} $(use_with ssl)"
331 else
332 myconf="${myconf} $(use_with ssl openssl)"
333 fi 519 fi
334 520
335 if mysql_version_is_at_least "5.0.60" ; then 521 if mysql_version_is_at_least "5.0.60" ; then
336 if use berkdb ; then 522 if use berkdb ; then
337 elog "Berkeley DB support was disabled due to build failures" 523 elog "Berkeley DB support was disabled due to build failures"
353 myconf="${myconf} --without-berkeley-db" 539 myconf="${myconf} --without-berkeley-db"
354 fi 540 fi
355 541
356 if mysql_version_is_at_least "4.1.3" ; then 542 if mysql_version_is_at_least "4.1.3" ; then
357 myconf="${myconf} --with-geometry" 543 myconf="${myconf} --with-geometry"
544 if [[ "${PN}" != "mysql-cluster" ]] ; then
358 myconf="${myconf} $(use_with cluster ndbcluster)" 545 myconf="${myconf} $(use_with cluster ndbcluster)"
546 fi
359 fi 547 fi
360 548
361 if mysql_version_is_at_least "4.1.3" && use extraengine ; then 549 if mysql_version_is_at_least "4.1.3" && use extraengine ; then
362 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html 550 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html
363 myconf="${myconf} --with-archive-storage-engine" 551 myconf="${myconf} --with-archive-storage-engine"
394 582
395configure_51() { 583configure_51() {
396 # TODO: !!!! readd --without-readline 584 # TODO: !!!! readd --without-readline
397 # the failure depend upon config/ac-macros/readline.m4 checking into 585 # the failure depend upon config/ac-macros/readline.m4 checking into
398 # readline.h instead of history.h 586 # readline.h instead of history.h
399 myconf="${myconf} $(use_with ssl)" 587 myconf="${myconf} $(use_with ssl ssl /usr)"
400 myconf="${myconf} --enable-assembler" 588 myconf="${myconf} --enable-assembler"
401 myconf="${myconf} --with-geometry" 589 myconf="${myconf} --with-geometry"
402 myconf="${myconf} --with-readline" 590 myconf="${myconf} --with-readline"
403 myconf="${myconf} --with-row-based-replication"
404 myconf="${myconf} --with-zlib=/usr/$(get_libdir)" 591 myconf="${myconf} --with-zlib-dir=/usr/"
405 myconf="${myconf} --without-pstack" 592 myconf="${myconf} --without-pstack"
593 myconf="${myconf} --with-plugindir=/usr/$(get_libdir)/mysql/plugin"
594
595 # This is an explict die here, because if we just forcibly disable it, then the
596 # user's data is not accessible.
597 use max-idx-128 && die "Bug #336027: upstream has a corruption issue with max-idx-128 presently"
406 use max-idx-128 && myconf="${myconf} --with-max-indexes=128" 598 #use max-idx-128 && myconf="${myconf} --with-max-indexes=128"
599 if [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then
600 myconf="${myconf} $(use_enable community community-features)"
601 if use community; then
602 myconf="${myconf} $(use_enable profiling)"
603 else
604 myconf="${myconf} --disable-profiling"
605 fi
606 fi
607
608 # Scan for all available plugins
609 local plugins_avail="$(
610 LANG=C \
611 find "${S}" \
612 \( \
613 -name 'plug.in' \
614 -o -iname 'configure.in' \
615 -o -iname 'configure.ac' \
616 \) \
617 -print0 \
618 | xargs -0 sed -r -n \
619 -e '/^MYSQL_STORAGE_ENGINE/{
620 s~MYSQL_STORAGE_ENGINE\([[:space:]]*\[?([-_a-z0-9]+)\]?.*,~\1 ~g ;
621 s~^([^ ]+).*~\1~gp;
622 }' \
623 | tr -s '\n' ' '
624 )"
407 625
408 # 5.1 introduces a new way to manage storage engines (plugins) 626 # 5.1 introduces a new way to manage storage engines (plugins)
409 # like configuration=none 627 # like configuration=none
628 # This base set are required, and will always be statically built.
410 local plugins="csv,myisam,myisammrg,heap" 629 local plugins_sta="csv myisam myisammrg heap"
630 local plugins_dyn=""
631 local plugins_dis="example ibmdb2i"
632
633 # These aren't actually required by the base set, but are really useful:
634 plugins_sta="${plugins_sta} archive blackhole"
635
636 # default in 5.5.4
637 if mysql_version_is_at_least "5.5.4" ; then
638 plugins_sta="${plugins_sta} partition"
639 fi
640 # Now the extras
411 if use extraengine ; then 641 if use extraengine ; then
412 # like configuration=max-no-ndb, archive and example removed in 5.1.11 642 # like configuration=max-no-ndb, archive and example removed in 5.1.11
413 plugins="${plugins},archive,blackhole,example,federated,partition" 643 # not added yet: ibmdb2i
644 # Not supporting as examples: example,daemon_example,ftexample
645 plugins_sta="${plugins_sta} partition"
414 646
647 if [[ "${PN}" != "mariadb" ]] ; then
415 elog "Before using the Federated storage engine, please be sure to read" 648 elog "Before using the Federated storage engine, please be sure to read"
416 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html" 649 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html"
650 plugins_dyn="${plugins_sta} federated"
651 else
652 elog "MariaDB includes the FederatedX engine. Be sure to read"
653 elog "http://askmonty.org/wiki/index.php/Manual:FederatedX_storage_engine"
654 plugins_dyn="${plugins_sta} federatedx"
417 fi 655 fi
656 else
657 plugins_dis="${plugins_dis} partition federated"
658 fi
418 659
419 # Upstream specifically requests that InnoDB always be built. 660 # Upstream specifically requests that InnoDB always be built:
420 plugins="${plugins},innobase" 661 # - innobase, innodb_plugin
662 # Build falcon if available for 6.x series.
663 for i in innobase falcon ; do
664 [ -e "${S}"/storage/${i} ] && plugins_sta="${plugins_sta} ${i}"
665 done
666 for i in innodb_plugin ; do
667 [ -e "${S}"/storage/${i} ] && plugins_dyn="${plugins_dyn} ${i}"
668 done
421 669
422 # like configuration=max-no-ndb 670 # like configuration=max-no-ndb
423 if use cluster ; then 671 if ( use cluster || [[ "${PN}" == "mysql-cluster" ]] ) ; then
424 plugins="${plugins},ndbcluster" 672 plugins_sta="${plugins_sta} ndbcluster partition"
673 plugins_dis="${plugins_dis//partition}"
425 myconf="${myconf} --with-ndb-binlog" 674 myconf="${myconf} --with-ndb-binlog"
675 else
676 plugins_dis="${plugins_dis} ndbcluster"
677 fi
678
679 if [[ "${PN}" == "mariadb" ]] ; then
680 # In MariaDB, InnoDB is packaged in the xtradb directory, so it's not
681 # caught above.
682 # This is not optional, without it several upstream testcases fail.
683 # Also strongly recommended by upstream.
684 if [[ "${PV}" < "5.2.0" ]] ; then
685 myconf="${myconf} --with-maria-tmp-tables"
686 plugins_sta="${plugins_sta} maria"
687 else
688 myconf="${myconf} --with-aria-tmp-tables"
689 plugins_sta="${plugins_sta} aria"
426 fi 690 fi
427 691
692 [ -e "${S}"/storage/innobase ] || [ -e "${S}"/storage/xtradb ] ||
693 die "The ${P} package doesn't provide innobase nor xtradb"
694
695 for i in innobase xtradb ; do
696 [ -e "${S}"/storage/${i} ] && plugins_sta="${plugins_sta} ${i}"
697 done
698
699 myconf="${myconf} $(use_with libevent)"
700
428 if mysql_version_is_at_least "5.2" ; then 701 if mysql_version_is_at_least "5.2" ; then
429 plugins="${plugins},falcon" 702 #This should include sphinx, but the 5.2.4 archive forgot the plug.in file
703 #for i in oqgraph sphinx ; do
704 for i in oqgraph ; do
705 use ${i} \
706 && plugins_dyn="${plugins_dyn} ${i}" \
707 || plugins_dis="${plugins_dis} ${i}"
708 done
430 fi 709 fi
710 fi
431 711
712 if pbxt_available && [[ "${PBXT_NEWSTYLE}" == "1" ]]; then
713 use pbxt \
714 && plugins_dyn="${plugins_dyn} pbxt" \
715 || plugins_dis="${plugins_dis} pbxt"
716 fi
717
718 use static && \
719 plugins_sta="${plugins_sta} ${plugins_dyn}" && \
720 plugins_dyn=""
721
722 einfo "Available plugins: ${plugins_avail}"
723 einfo "Dynamic plugins: ${plugins_dyn}"
724 einfo "Static plugins: ${plugins_sta}"
725 einfo "Disabled plugins: ${plugins_dis}"
726
727 # These are the static plugins
432 myconf="${myconf} --with-plugins=${plugins}" 728 myconf="${myconf} --with-plugins=${plugins_sta// /,}"
729 # And the disabled ones
730 for i in ${plugins_dis} ; do
731 myconf="${myconf} --without-plugin-${i}"
732 done
433} 733}
434 734
435pbxt_src_configure() { 735pbxt_src_configure() {
436 mysql_init_vars 736 mysql_init_vars
437 737
438 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null 738 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
439 739
440 einfo "Reconfiguring dir '${PWD}'" 740 einfo "Reconfiguring dir '${PWD}'"
441 AT_GNUCONF_UPDATE="yes" eautoreconf 741 eautoreconf
442 742
443 local myconf="" 743 local myconf=""
444 myconf="${myconf} --with-mysql=${S} --libdir=${D}/${MY_LIBDIR}" 744 myconf="${myconf} --with-mysql=${S} --libdir=/usr/$(get_libdir)"
445 use debug && myconf="${myconf} --with-debug=full" 745 use debug && myconf="${myconf} --with-debug=full"
446 # TODO: is it safe/needed to use econf here ?
447 ./configure ${myconf} || die "Problem configuring PBXT storage engine" 746 econf ${myconf} || die "Problem configuring PBXT storage engine"
448} 747}
449 748
450pbxt_src_compile() { 749pbxt_src_compile() {
750
451 # Be backwards compatible for now 751 # Be backwards compatible for now
452 if [[ $EAPI != 2 ]]; then 752 if [[ $EAPI != 2 ]]; then
453 pbxt_src_configure 753 pbxt_src_configure
454 fi 754 fi
455 # TODO: is it safe/needed to use emake here ? 755 # TODO: is it safe/needed to use emake here ?
459 # TODO: modify test suite for PBXT 759 # TODO: modify test suite for PBXT
460} 760}
461 761
462pbxt_src_install() { 762pbxt_src_install() {
463 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null 763 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
464 make install || die "Failed to install PBXT" 764 emake install DESTDIR="${D}" || die "Failed to install PBXT"
465 popd 765 popd
466} 766}
467 767
468# 768#
469# EBUILD FUNCTIONS 769# EBUILD FUNCTIONS
470# 770#
771# @FUNCTION: mysql_pkg_setup
772# @DESCRIPTION:
773# Perform some basic tests and tasks during pkg_setup phase:
774# die if FEATURES="test", USE="-minimal" and not using FEATURES="userpriv"
775# check for conflicting use flags
776# create new user and group for mysql
777# warn about deprecated features
471mysql_pkg_setup() { 778mysql_pkg_setup() {
472 if hasq test ${FEATURES} ; then 779 if has test ${FEATURES} ; then
473 if ! use minimal ; then 780 if ! use minimal ; then
474 if [[ $UID -eq 0 ]]; then 781 if [[ $UID -eq 0 ]]; then
475 eerror "Testing with FEATURES=-userpriv is no longer supported by upstream. Tests MUST be run as non-root." 782 eerror "Testing with FEATURES=-userpriv is no longer supported by upstream. Tests MUST be run as non-root."
476 fi 783 fi
477 fi 784 fi
478 fi 785 fi
479 786
787 # bug 350844
788 case "${EAPI:-0}" in
789 0 | 1)
790 if use static && !built_with_use sys-libs/ncurses static-libs; then
791 die "To build MySQL statically you need to enable static-libs for sys-libs/ncurses"
792 fi
793 ;;
794 esac
795
480 # Check for USE flag problems in pkg_setup 796 # Check for USE flag problems in pkg_setup
481 if use static && use ssl ; then 797 if use static && use ssl ; then
482 eerror "MySQL does not support being built statically with SSL support enabled!"
483 die "MySQL does not support being built statically with SSL support enabled!" 798 M="MySQL does not support being built statically with SSL support enabled!"
799 eerror "${M}"
800 die "${M}"
801 fi
802
803 if mysql_version_is_at_least "5.1.51" \
804 && ! mysql_version_is_at_least "5.2" \
805 && use debug ; then
806 # Also in package.use.mask
807 die "Bug #344885: Upstream has broken USE=debug for 5.1 series >=5.1.51"
484 fi 808 fi
485 809
486 if ! mysql_version_is_at_least "5.0" \ 810 if ! mysql_version_is_at_least "5.0" \
487 && use raid \ 811 && use raid \
488 && use static ; then 812 && use static ; then
490 eerror "with RAID support enabled." 814 eerror "with RAID support enabled."
491 die "USE flags 'raid' and 'static' conflict!" 815 die "USE flags 'raid' and 'static' conflict!"
492 fi 816 fi
493 817
494 if mysql_version_is_at_least "4.1.3" \ 818 if mysql_version_is_at_least "4.1.3" \
495 && ( use cluster || use extraengine ) \ 819 && ( use cluster || use extraengine || use embedded ) \
496 && use minimal ; then 820 && use minimal ; then
497 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
498 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 821 M="USE flags 'cluster', 'extraengine', 'embedded' conflict with 'minimal' USE flag!"
822 eerror "${M}"
823 die "${M}"
824 fi
825
826 if mysql_version_is_at_least "5.1" \
827 && xtradb_patch_available \
828 && use xtradb \
829 && use embedded ; then
830 M="USE flags 'xtradb' and 'embedded' conflict and cause build failures"
831 eerror "${M}"
832 die "${M}"
833 fi
834
835 # Bug #290570, 284946, 307251
836 # Upstream changes made us need a fairly new GCC4.
837 # But only for 5.0.8[3-6]!
838 if mysql_version_is_at_least "5.0.83" && ! mysql_version_is_at_least 5.0.87 ; then
839 GCC_VER=$(gcc-version)
840 case ${GCC_VER} in
841 2*|3*|4.0|4.1|4.2)
842 eerror "Some releases of MySQL required a very new GCC, and then"
843 eerror "later release relaxed that requirement again. Either pick a"
844 eerror "MySQL >=5.0.87, or use a newer GCC."
845 die "Active GCC too old!" ;;
846 esac
499 fi 847 fi
500 848
501 # This should come after all of the die statements 849 # This should come after all of the die statements
502 enewgroup mysql 60 || die "problem adding 'mysql' group" 850 enewgroup mysql 60 || die "problem adding 'mysql' group"
503 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user" 851 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
504 852
505 mysql_check_version_range "4.0 to 5.0.99.99" \ 853 mysql_check_version_range "4.0 to 5.0.99.99" \
506 && use berkdb \ 854 && use berkdb \
507 && elog "Berkeley DB support is deprecated and will be removed in future versions!" 855 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
508}
509 856
857 if [ "${PN}" != "mysql-cluster" ] && use cluster; then
858 ewarn "Upstream has noted that the NDB cluster support in the 5.0 and"
859 ewarn "5.1 series should NOT be put into production. In the near"
860 ewarn "future, it will be disabled from building."
861 ewarn ""
862 ewarn "If you need NDB support, you should instead move to the new"
863 ewarn "mysql-cluster package that represents that upstream NDB"
864 ewarn "development."
865 fi
866}
867
868# @FUNCTION: mysql_src_unpack
869# @DESCRIPTION:
870# Unpack the source code and call mysql_src_prepare for EAPI < 2.
510mysql_src_unpack() { 871mysql_src_unpack() {
511 # Initialize the proper variables first 872 # Initialize the proper variables first
512 mysql_init_vars 873 mysql_init_vars
513 874
514 unpack ${A} 875 unpack ${A}
516 [[ "${MY_EXTRAS_VER}" == "live" ]] && S="${WORKDIR}/mysql-extras" git_src_unpack 877 [[ "${MY_EXTRAS_VER}" == "live" ]] && S="${WORKDIR}/mysql-extras" git_src_unpack
517 878
518 mv -f "${WORKDIR}/${MY_SOURCEDIR}" "${S}" 879 mv -f "${WORKDIR}/${MY_SOURCEDIR}" "${S}"
519 880
520 # Be backwards compatible for now 881 # Be backwards compatible for now
521 if [[ $EAPI != 2 ]]; then 882 case ${EAPI:-0} in
522 mysql_src_prepare 883 2) : ;;
523 fi 884 0 | 1) mysql_src_prepare ;;
885 esac
524} 886}
525 887
888# @FUNCTION: mysql_src_prepare
889# @DESCRIPTION:
890# Apply patches to the source code and remove unneeded bundled libs.
526mysql_src_prepare() { 891mysql_src_prepare() {
527 cd "${S}" 892 cd "${S}"
528 893
529 # Apply the patches for this MySQL version 894 # Apply the patches for this MySQL version
530 EPATCH_SUFFIX="patch" 895 EPATCH_SUFFIX="patch"
534 # Now link in right patches 899 # Now link in right patches
535 mysql_mv_patches 900 mysql_mv_patches
536 # And apply 901 # And apply
537 epatch 902 epatch
538 903
539 # Additional checks, remove bundled zlib 904 # last -fPIC fixup, per bug #305873
905 i="${S}"/storage/innodb_plugin/plug.in
906 [ -f "${i}" ] && sed -i -e '/CFLAGS/s,-prefer-non-pic,,g' "${i}"
907
908 # Additional checks, remove bundled zlib (Cluster needs this, for static
909 # memory management in zlib, leave available for Cluster)
910 if [[ "${PN}" != "mysql-cluster" ]] ; then
540 rm -f "${S}/zlib/"*.[ch] 911 rm -f "${S}/zlib/"*.[ch]
541 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in" 912 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in"
913 fi
542 rm -f "scripts/mysqlbug" 914 rm -f "scripts/mysqlbug"
543 915
544 # Make charsets install in the right place 916 # Make charsets install in the right place
545 find . -name 'Makefile.am' \ 917 find . -name 'Makefile.am' \
546 -exec sed --in-place -e 's!$(pkgdatadir)!'${MY_SHAREDSTATEDIR}'!g' {} \; 918 -exec sed --in-place -e 's!$(pkgdatadir)!'${MY_SHAREDSTATEDIR}'!g' {} \;
547 919
548 if mysql_version_is_at_least "4.1" ; then 920 if mysql_version_is_at_least "4.1" ; then
549 # Remove what needs to be recreated, so we're sure it's actually done 921 # Remove what needs to be recreated, so we're sure it's actually done
922 einfo "Cleaning up old buildscript files"
550 find . -name Makefile \ 923 find . -name Makefile \
551 -o -name Makefile.in \ 924 -o -name Makefile.in \
552 -o -name configure \ 925 -o -name configure \
553 -exec rm -f {} \; 926 -exec rm -f {} \;
554 rm -f "ltmain.sh" 927 rm -f "ltmain.sh"
555 rm -f "scripts/mysqlbug" 928 rm -f "scripts/mysqlbug"
556 fi 929 fi
557 930
558 local rebuilddirlist d 931 local rebuilddirlist d
559 932
933 if xtradb_patch_available && use xtradb ; then
934 einfo "Adding storage engine: Percona XtraDB (replacing InnoDB)"
935 pushd "${S}"/storage >/dev/null
936 i="innobase"
937 o="${WORKDIR}/storage-${i}.mysql-upstream"
938 # Have we been here already?
939 [ -d "${o}" ] && rm -f "${i}"
940 # Or maybe we haven't
941 [ -d "${i}" -a ! -d "${o}" ] && mv "${i}" "${o}"
942 cp -ral "${WORKDIR}/${XTRADB_P}" "${i}"
943 popd >/dev/null
944 fi
945
946 if pbxt_patch_available && [[ "${PBXT_NEWSTYLE}" == "1" ]] && use pbxt ; then
947 einfo "Adding storage engine: PBXT"
948 pushd "${S}"/storage >/dev/null
949 i='pbxt'
950 [ -d "${i}" ] && rm -rf "${i}"
951 cp -ral "${WORKDIR}/${PBXT_P}" "${i}"
952 popd >/dev/null
953 fi
954
560 if mysql_version_is_at_least "5.1.12" ; then 955 if mysql_version_is_at_least "5.1.12" ; then
561 rebuilddirlist="." 956 rebuilddirlist="."
957 # This does not seem to be needed presently. robbat2 2010/02/23
958 #einfo "Updating innobase cmake"
562 # TODO: check this with a cmake expert 959 ## TODO: check this with a cmake expert
563 cmake \ 960 #cmake \
564 -DCMAKE_C_COMPILER=$(type -P $(tc-getCC)) \ 961 # -DCMAKE_C_COMPILER=$(type -P $(tc-getCC)) \
565 -DCMAKE_CXX_COMPILER=$(type -P $(tc-getCXX)) \ 962 # -DCMAKE_CXX_COMPILER=$(type -P $(tc-getCXX)) \
566 "storage/innobase" 963 # "storage/innobase"
567 else 964 else
568 rebuilddirlist=". innobase" 965 rebuilddirlist=". innobase"
569 fi 966 fi
570 967
571 for d in ${rebuilddirlist} ; do 968 for d in ${rebuilddirlist} ; do
572 einfo "Reconfiguring dir '${d}'" 969 einfo "Reconfiguring dir '${d}'"
573 pushd "${d}" &>/dev/null 970 pushd "${d}" &>/dev/null
574 AT_GNUCONF_UPDATE="yes" eautoreconf 971 eautoreconf
575 popd &>/dev/null 972 popd &>/dev/null
576 done 973 done
577 974
578 if mysql_check_version_range "4.1 to 5.0.99.99" \ 975 if mysql_check_version_range "4.1 to 5.0.99.99" \
579 && use berkdb ; then 976 && use berkdb ; then
977 einfo "Fixing up berkdb buildsystem"
580 [[ -w "bdb/dist/ltmain.sh" ]] && cp -f "ltmain.sh" "bdb/dist/ltmain.sh" 978 [[ -w "bdb/dist/ltmain.sh" ]] && cp -f "ltmain.sh" "bdb/dist/ltmain.sh"
581 cp -f "/usr/share/aclocal/libtool.m4" "bdb/dist/aclocal/libtool.ac" \ 979 cp -f "/usr/share/aclocal/libtool.m4" "bdb/dist/aclocal/libtool.ac" \
582 || die "Could not copy libtool.m4 to bdb/dist/" 980 || die "Could not copy libtool.m4 to bdb/dist/"
583 #These files exist only with libtool-2*, and need to be included. 981 #These files exist only with libtool-2*, and need to be included.
584 if [ -f '/usr/share/aclocal/ltsugar.m4' ]; then 982 if [ -f '/usr/share/aclocal/ltsugar.m4' ]; then
592 || die "Failed bdb reconfigure" 990 || die "Failed bdb reconfigure"
593 popd &>/dev/null 991 popd &>/dev/null
594 fi 992 fi
595} 993}
596 994
995# @FUNCTION: mysql_src_configure
996# @DESCRIPTION:
997# Configure mysql to build the code for Gentoo respecting the use flags.
597mysql_src_configure() { 998mysql_src_configure() {
598 # Make sure the vars are correctly initialized 999 # Make sure the vars are correctly initialized
599 mysql_init_vars 1000 mysql_init_vars
600 1001
601 # $myconf is modified by the configure_* functions 1002 # $myconf is modified by the configure_* functions
630 && CXXFLAGS="${CXXFLAGS} -fno-implicit-templates" 1031 && CXXFLAGS="${CXXFLAGS} -fno-implicit-templates"
631 export CXXFLAGS 1032 export CXXFLAGS
632 1033
633 # bug #283926, with GCC4.4, this is required to get correct behavior. 1034 # bug #283926, with GCC4.4, this is required to get correct behavior.
634 append-flags -fno-strict-aliasing 1035 append-flags -fno-strict-aliasing
1036
1037 # bug #335185, #335995, with >= GCC4.3.3 on x86 only, omit-frame-pointer
1038 # causes a mis-compile.
1039 # Upstream bugs:
1040 # http://gcc.gnu.org/bugzilla/show_bug.cgi?id=38562
1041 # http://bugs.mysql.com/bug.php?id=45205
1042 use x86 && version_is_at_least "4.3.3" "$(gcc-fullversion)" && \
1043 append-flags -fno-omit-frame-pointer && \
1044 filter-flags -fomit-frame-pointer
635 1045
636 econf \ 1046 econf \
637 --libexecdir="/usr/sbin" \ 1047 --libexecdir="/usr/sbin" \
638 --sysconfdir="${MY_SYSCONFDIR}" \ 1048 --sysconfdir="${MY_SYSCONFDIR}" \
639 --localstatedir="${MY_LOCALSTATEDIR}" \ 1049 --localstatedir="${MY_LOCALSTATEDIR}" \
643 --with-low-memory \ 1053 --with-low-memory \
644 --with-client-ldflags=-lstdc++ \ 1054 --with-client-ldflags=-lstdc++ \
645 --enable-thread-safe-client \ 1055 --enable-thread-safe-client \
646 --with-comment="Gentoo Linux ${PF}" \ 1056 --with-comment="Gentoo Linux ${PF}" \
647 --without-docs \ 1057 --without-docs \
1058 --with-LIBDIR="$(get_libdir)" \
648 ${myconf} || die "econf failed" 1059 ${myconf} || die "econf failed"
649 1060
650 # TODO: Move this before autoreconf !!! 1061 # TODO: Move this before autoreconf !!!
651 find . -type f -name Makefile -print0 \ 1062 find . -type f -name Makefile -print0 \
652 | xargs -0 -n100 sed -i \ 1063 | xargs -0 -n100 sed -i \
653 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|' 1064 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|'
654 1065
655 if [[ $EAPI == 2 ]]; then 1066 if [[ $EAPI == 2 ]] && [[ "${PBXT_NEWSTYLE}" != "1" ]]; then
656 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_configure 1067 pbxt_patch_available && use pbxt && pbxt_src_configure
657 fi 1068 fi
658} 1069}
659 1070
1071# @FUNCTION: mysql_src_compile
1072# @DESCRIPTION:
1073# Compile the mysql code.
660mysql_src_compile() { 1074mysql_src_compile() {
661 # Be backwards compatible for now 1075 # Be backwards compatible for now
662 if [[ $EAPI != 2 ]]; then 1076 case ${EAPI:-0} in
1077 2) : ;;
663 mysql_src_configure 1078 0 | 1) mysql_src_configure ;;
664 fi 1079 esac
665 1080
666 emake || die "emake failed" 1081 emake || die "emake failed"
667 1082
668 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_compile 1083 if [[ "${PBXT_NEWSTYLE}" != "1" ]]; then
1084 pbxt_patch_available && use pbxt && pbxt_src_compile
1085 fi
669} 1086}
670 1087
1088# @FUNCTION: mysql_src_install
1089# @DESCRIPTION:
1090# Install mysql.
671mysql_src_install() { 1091mysql_src_install() {
672 # Make sure the vars are correctly initialized 1092 # Make sure the vars are correctly initialized
673 mysql_init_vars 1093 mysql_init_vars
674 1094
675 emake install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die "emake install failed" 1095 emake install \
1096 DESTDIR="${D}" \
1097 benchdir_root="${MY_SHAREDSTATEDIR}" \
1098 testroot="${MY_SHAREDSTATEDIR}" \
1099 || die "emake install failed"
676 1100
677 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_install 1101 if [[ "${PBXT_NEWSTYLE}" != "1" ]]; then
1102 pbxt_patch_available && use pbxt && pbxt_src_install
1103 fi
678 1104
679 # Convenience links 1105 # Convenience links
680 einfo "Making Convenience links for mysqlcheck multi-call binary" 1106 einfo "Making Convenience links for mysqlcheck multi-call binary"
681 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlanalyze" 1107 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlanalyze"
682 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlrepair" 1108 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlrepair"
686 einfo "Removing duplicate /usr/share/mysql files" 1112 einfo "Removing duplicate /usr/share/mysql files"
687 rm -Rf "${D}/usr/share/info" 1113 rm -Rf "${D}/usr/share/info"
688 for removeme in "mysql-log-rotate" mysql.server* \ 1114 for removeme in "mysql-log-rotate" mysql.server* \
689 binary-configure* my-*.cnf mi_test_all* 1115 binary-configure* my-*.cnf mi_test_all*
690 do 1116 do
691 rm -f "${D}"/usr/share/mysql/${removeme} 1117 rm -f "${D}"/${MY_SHAREDSTATEDIR}/${removeme}
692 done 1118 done
693 1119
694 # Clean up stuff for a minimal build 1120 # Clean up stuff for a minimal build
695 if use minimal ; then 1121 if use minimal ; then
696 einfo "Remove all extra content for minimal build" 1122 einfo "Remove all extra content for minimal build"
698 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam} 1124 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam}
699 rm -f "${D}/usr/sbin/mysqld" 1125 rm -f "${D}/usr/sbin/mysqld"
700 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a 1126 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a
701 fi 1127 fi
702 1128
1129 # Unless they explicitly specific USE=test, then do not install the
1130 # testsuite. It DOES have a use to be installed, esp. when you want to do a
1131 # validation of your database configuration after tuning it.
1132 if use !test ; then
1133 rm -rf "${D}"/${MY_SHAREDSTATEDIR}/mysql-test
1134 fi
1135
703 # Configuration stuff 1136 # Configuration stuff
704 if mysql_version_is_at_least "4.1" ; then 1137 case ${MYSQL_PV_MAJOR} in
705 mysql_mycnf_version="4.1"
706 else
707 mysql_mycnf_version="4.0" 1138 3*|4.0) mysql_mycnf_version="4.0" ;;
708 fi 1139 4.[1-9]|5.0) mysql_mycnf_version="4.1" ;;
709 einfo "Building default my.cnf" 1140 5.[1-9]|6*|7*) mysql_mycnf_version="5.1" ;;
1141 esac
1142 einfo "Building default my.cnf (${mysql_mycnf_version})"
710 insinto "${MY_SYSCONFDIR}" 1143 insinto "${MY_SYSCONFDIR}"
711 doins scripts/mysqlaccess.conf 1144 doins scripts/mysqlaccess.conf
1145 mycnf_src="my.cnf-${mysql_mycnf_version}"
712 sed -e "s!@DATADIR@!${MY_DATADIR}!g" \ 1146 sed -e "s!@DATADIR@!${MY_DATADIR}!g" \
713 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \ 1147 "${FILESDIR}/${mycnf_src}" \
714 > "${TMPDIR}/my.cnf.ok" 1148 > "${TMPDIR}/my.cnf.ok"
715 if mysql_version_is_at_least "4.1" && use latin1 ; then 1149 if use latin1 ; then
716 sed -e "s|utf8|latin1|g" -i "${TMPDIR}/my.cnf.ok" 1150 sed -i \
1151 -e "/character-set/s|utf8|latin1|g" \
1152 "${TMPDIR}/my.cnf.ok"
717 fi 1153 fi
718 newins "${TMPDIR}/my.cnf.ok" my.cnf 1154 newins "${TMPDIR}/my.cnf.ok" my.cnf
719 1155
720 # Minimal builds don't have the MySQL server 1156 # Minimal builds don't have the MySQL server
721 if ! use minimal ; then 1157 if ! use minimal ; then
736 done 1172 done
737 fi 1173 fi
738 1174
739 # Docs 1175 # Docs
740 einfo "Installing docs" 1176 einfo "Installing docs"
741 dodoc README COPYING ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE 1177 for i in README ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE ; do
1178 [[ -f "$i" ]] && dodoc "$i"
1179 done
742 doinfo "${S}"/Docs/mysql.info 1180 doinfo "${S}"/Docs/mysql.info
743 1181
744 # Minimal builds don't have the MySQL server 1182 # Minimal builds don't have the MySQL server
745 if ! use minimal ; then 1183 if ! use minimal ; then
746 einfo "Including support files and sample configurations" 1184 einfo "Including support files and sample configurations"
748 for script in \ 1186 for script in \
749 "${S}"/support-files/my-*.cnf \ 1187 "${S}"/support-files/my-*.cnf \
750 "${S}"/support-files/magic \ 1188 "${S}"/support-files/magic \
751 "${S}"/support-files/ndb-config-2-node.ini 1189 "${S}"/support-files/ndb-config-2-node.ini
752 do 1190 do
753 dodoc "${script}" 1191 [[ -f "$script" ]] && dodoc "${script}"
754 done 1192 done
755 1193
756 docinto "scripts" 1194 docinto "scripts"
757 for script in "${S}"/scripts/mysql* ; do 1195 for script in "${S}"/scripts/mysql* ; do
758 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}" 1196 [[ -f "$script" ]] && [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
759 done 1197 done
760 1198
761 fi 1199 fi
762 1200
763 mysql_lib_symlinks "${D}" 1201 mysql_lib_symlinks "${D}"
764} 1202}
765 1203
1204# @FUNCTION: mysql_pkg_preinst
1205# @DESCRIPTION:
1206# Create the user and groups for mysql - die if that fails.
766mysql_pkg_preinst() { 1207mysql_pkg_preinst() {
767 enewgroup mysql 60 || die "problem adding 'mysql' group" 1208 enewgroup mysql 60 || die "problem adding 'mysql' group"
768 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user" 1209 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
769} 1210}
770 1211
1212# @FUNCTION: mysql_pkg_postinst
1213# @DESCRIPTION:
1214# Run post-installation tasks:
1215# create the dir for logfiles if non-existant
1216# touch the logfiles and secure them
1217# install scripts
1218# issue required steps for optional features
1219# issue deprecation warnings
771mysql_pkg_postinst() { 1220mysql_pkg_postinst() {
772 # Make sure the vars are correctly initialized 1221 # Make sure the vars are correctly initialized
773 mysql_init_vars 1222 mysql_init_vars
774 1223
775 # Check FEATURES="collision-protect" before removing this 1224 # Check FEATURES="collision-protect" before removing this
786 for script in \ 1235 for script in \
787 support-files/my-*.cnf \ 1236 support-files/my-*.cnf \
788 support-files/magic \ 1237 support-files/magic \
789 support-files/ndb-config-2-node.ini 1238 support-files/ndb-config-2-node.ini
790 do 1239 do
1240 [[ -f "${script}" ]] \
791 dodoc "${script}" 1241 && dodoc "${script}"
792 done 1242 done
793 1243
794 docinto "scripts" 1244 docinto "scripts"
795 for script in scripts/mysql* ; do 1245 for script in scripts/mysql* ; do
1246 [[ -f "${script}" ]] \
796 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}" 1247 && [[ "${script%.sh}" == "${script}" ]] \
1248 && dodoc "${script}"
797 done 1249 done
798 1250
799 einfo 1251 einfo
800 elog "You might want to run:" 1252 elog "You might want to run:"
801 elog "\"emerge --config =${CATEGORY}/${PF}\"" 1253 elog "\"emerge --config =${CATEGORY}/${PF}\""
802 elog "if this is a new install." 1254 elog "if this is a new install."
803 einfo 1255 einfo
804 fi
805 1256
806 if mysql_version_is_at_least "5.1.12" && use pbxt ; then 1257 einfo
1258 elog "If you are upgrading major versions, you should run the"
1259 elog "mysql_upgrade tool."
1260 einfo
1261 fi
1262
1263 if pbxt_available && use pbxt ; then
807 # TODO: explain it better 1264 # TODO: explain it better
808 elog " mysql> INSTALL PLUGIN pbxt SONAME 'libpbxt.so';" 1265 elog " mysql> INSTALL PLUGIN pbxt SONAME 'libpbxt.so';"
809 elog " mysql> CREATE TABLE t1 (c1 int, c2 text) ENGINE=pbxt;" 1266 elog " mysql> CREATE TABLE t1 (c1 int, c2 text) ENGINE=pbxt;"
810 elog "if, after that, you cannot start the MySQL server," 1267 elog "if, after that, you cannot start the MySQL server,"
811 elog "remove the ${MY_DATADIR}/mysql/plugin.* files, then" 1268 elog "remove the ${MY_DATADIR}/mysql/plugin.* files, then"
821 mysql_check_version_range "4.0 to 5.0.99.99" \ 1278 mysql_check_version_range "4.0 to 5.0.99.99" \
822 && use berkdb \ 1279 && use berkdb \
823 && elog "Berkeley DB support is deprecated and will be removed in future versions!" 1280 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
824} 1281}
825 1282
1283# @FUNCTION: mysql_pkg_config
1284# @DESCRIPTION:
1285# Configure mysql environment.
826mysql_pkg_config() { 1286mysql_pkg_config() {
827 local old_MY_DATADIR="${MY_DATADIR}" 1287 local old_MY_DATADIR="${MY_DATADIR}"
828 1288
829 # Make sure the vars are correctly initialized 1289 # Make sure the vars are correctly initialized
830 mysql_init_vars 1290 mysql_init_vars
859 fi 1319 fi
860 fi 1320 fi
861 1321
862 local pwd1="a" 1322 local pwd1="a"
863 local pwd2="b" 1323 local pwd2="b"
864 local maxtry=5 1324 local maxtry=15
1325
1326 if [ -z "${MYSQL_ROOT_PASSWORD}" -a -f "${ROOT}/root/.my.cnf" ]; then
1327 MYSQL_ROOT_PASSWORD="$(sed -n -e '/^password=/s,^password=,,gp' "${ROOT}/root/.my.cnf")"
1328 fi
865 1329
866 if [[ -d "${ROOT}/${MY_DATADIR}/mysql" ]] ; then 1330 if [[ -d "${ROOT}/${MY_DATADIR}/mysql" ]] ; then
867 ewarn "You have already a MySQL database in place." 1331 ewarn "You have already a MySQL database in place."
868 ewarn "(${ROOT}/${MY_DATADIR}/*)" 1332 ewarn "(${ROOT}/${MY_DATADIR}/*)"
869 ewarn "Please rename or delete it if you wish to replace it." 1333 ewarn "Please rename or delete it if you wish to replace it."
872 1336
873 # Bug #213475 - MySQL _will_ object strenously if your machine is named 1337 # Bug #213475 - MySQL _will_ object strenously if your machine is named
874 # localhost. Also causes weird failures. 1338 # localhost. Also causes weird failures.
875 [[ "${HOSTNAME}" == "localhost" ]] && die "Your machine must NOT be named localhost" 1339 [[ "${HOSTNAME}" == "localhost" ]] && die "Your machine must NOT be named localhost"
876 1340
877 einfo "Creating the mysql database and setting proper" 1341 if [ -z "${MYSQL_ROOT_PASSWORD}" ]; then
878 einfo "permissions on it ..."
879 1342
880 einfo "Insert a password for the mysql 'root' user" 1343 einfo "Please provide a password for the mysql 'root' user now, in the"
1344 einfo "MYSQL_ROOT_PASSWORD env var or through the /root/.my.cnf file."
881 ewarn "Avoid [\"'\\_%] characters in the password" 1345 ewarn "Avoid [\"'\\_%] characters in the password"
882 read -rsp " >" pwd1 ; echo 1346 read -rsp " >" pwd1 ; echo
883 1347
884 einfo "Retype the password" 1348 einfo "Retype the password"
885 read -rsp " >" pwd2 ; echo 1349 read -rsp " >" pwd2 ; echo
886 1350
887 if [[ "x$pwd1" != "x$pwd2" ]] ; then 1351 if [[ "x$pwd1" != "x$pwd2" ]] ; then
888 die "Passwords are not the same" 1352 die "Passwords are not the same"
1353 fi
1354 MYSQL_ROOT_PASSWORD="${pwd1}"
1355 unset pwd1 pwd2
889 fi 1356 fi
890 1357
891 local options="" 1358 local options=""
892 local sqltmp="$(emktemp)" 1359 local sqltmp="$(emktemp)"
893 1360
907 [[ -f "${ROOT}/${MY_DATADIR}/mysql/user.frm" ]] \ 1374 [[ -f "${ROOT}/${MY_DATADIR}/mysql/user.frm" ]] \
908 || die "MySQL databases not installed" 1375 || die "MySQL databases not installed"
909 chown -R mysql:mysql "${ROOT}/${MY_DATADIR}" 2>/dev/null 1376 chown -R mysql:mysql "${ROOT}/${MY_DATADIR}" 2>/dev/null
910 chmod 0750 "${ROOT}/${MY_DATADIR}" 2>/dev/null 1377 chmod 0750 "${ROOT}/${MY_DATADIR}" 2>/dev/null
911 1378
1379 # Figure out which options we need to disable to do the setup
1380 helpfile="${TMPDIR}/mysqld-help"
1381 ${ROOT}/usr/sbin/mysqld --verbose --help >"${helpfile}" 2>/dev/null
1382 for opt in grant-tables host-cache name-resolve networking slave-start bdb \
1383 federated innodb ssl log-bin relay-log slow-query-log external-locking \
1384 ndbcluster \
1385 ; do
1386 optexp="--(skip-)?${opt}" optfull="--skip-${opt}"
1387 egrep -sq -- "${optexp}" "${helpfile}" && options="${options} ${optfull}"
1388 done
1389 # But some options changed names
1390 egrep -sq external-locking "${helpfile}" && \
1391 options="${options/skip-locking/skip-external-locking}"
1392
912 if mysql_version_is_at_least "4.1.3" ; then 1393 if mysql_version_is_at_least "4.1.3" ; then
913 options="--skip-ndbcluster"
914
915 # Filling timezones, see 1394 # Filling timezones, see
916 # http://dev.mysql.com/doc/mysql/en/time-zone-support.html 1395 # http://dev.mysql.com/doc/mysql/en/time-zone-support.html
917 "${ROOT}/usr/bin/mysql_tzinfo_to_sql" "${ROOT}/usr/share/zoneinfo" > "${sqltmp}" 2>/dev/null 1396 "${ROOT}/usr/bin/mysql_tzinfo_to_sql" "${ROOT}/usr/share/zoneinfo" > "${sqltmp}" 2>/dev/null
918 1397
919 if [[ -r "${help_tables}" ]] ; then 1398 if [[ -r "${help_tables}" ]] ; then
920 cat "${help_tables}" >> "${sqltmp}" 1399 cat "${help_tables}" >> "${sqltmp}"
921 fi 1400 fi
922 fi 1401 fi
1402
1403 einfo "Creating the mysql database and setting proper"
1404 einfo "permissions on it ..."
923 1405
924 local socket="${ROOT}/var/run/mysqld/mysqld${RANDOM}.sock" 1406 local socket="${ROOT}/var/run/mysqld/mysqld${RANDOM}.sock"
925 local pidfile="${ROOT}/var/run/mysqld/mysqld${RANDOM}.pid" 1407 local pidfile="${ROOT}/var/run/mysqld/mysqld${RANDOM}.pid"
926 local mysqld="${ROOT}/usr/sbin/mysqld \ 1408 local mysqld="${ROOT}/usr/sbin/mysqld \
927 ${options} \ 1409 ${options} \
928 --user=mysql \ 1410 --user=mysql \
929 --skip-grant-tables \
930 --basedir=${ROOT}/usr \ 1411 --basedir=${ROOT}/usr \
931 --datadir=${ROOT}/${MY_DATADIR} \ 1412 --datadir=${ROOT}/${MY_DATADIR} \
932 --skip-innodb \
933 --skip-bdb \
934 --skip-networking \
935 --max_allowed_packet=8M \ 1413 --max_allowed_packet=8M \
936 --net_buffer_length=16K \ 1414 --net_buffer_length=16K \
1415 --default-storage-engine=MyISAM \
937 --socket=${socket} \ 1416 --socket=${socket} \
938 --pid-file=${pidfile}" 1417 --pid-file=${pidfile}"
1418 #einfo "About to start mysqld: ${mysqld}"
1419 ebegin "Starting mysqld"
939 ${mysqld} & 1420 ${mysqld} &
1421 rc=$?
940 while ! [[ -S "${socket}" || "${maxtry}" -lt 1 ]] ; do 1422 while ! [[ -S "${socket}" || "${maxtry}" -lt 1 ]] ; do
941 maxtry=$((${maxtry}-1)) 1423 maxtry=$((${maxtry}-1))
942 echo -n "." 1424 echo -n "."
943 sleep 1 1425 sleep 1
944 done 1426 done
1427 eend $rc
945 1428
1429 if ! [[ -S "${socket}" ]]; then
1430 die "Completely failed to start up mysqld with: ${mysqld}"
1431 fi
1432
1433 ebegin "Setting root password"
946 # Do this from memory, as we don't want clear text passwords in temp files 1434 # Do this from memory, as we don't want clear text passwords in temp files
947 local sql="UPDATE mysql.user SET Password = PASSWORD('${pwd1}') WHERE USER='root'" 1435 local sql="UPDATE mysql.user SET Password = PASSWORD('${MYSQL_ROOT_PASSWORD}') WHERE USER='root'"
948 "${ROOT}/usr/bin/mysql" \ 1436 "${ROOT}/usr/bin/mysql" \
949 --socket=${socket} \ 1437 --socket=${socket} \
950 -hlocalhost \ 1438 -hlocalhost \
951 -e "${sql}" 1439 -e "${sql}"
1440 eend $?
952 1441
953 einfo "Loading \"zoneinfo\", this step may require a few seconds ..." 1442 ebegin "Loading \"zoneinfo\", this step may require a few seconds ..."
954
955 "${ROOT}/usr/bin/mysql" \ 1443 "${ROOT}/usr/bin/mysql" \
956 --socket=${socket} \ 1444 --socket=${socket} \
957 -hlocalhost \ 1445 -hlocalhost \
958 -uroot \ 1446 -uroot \
959 -p"${pwd1}" \ 1447 -p"${MYSQL_ROOT_PASSWORD}" \
960 mysql < "${sqltmp}" 1448 mysql < "${sqltmp}"
1449 rc=$?
1450 eend $?
1451 [ $rc -ne 0 ] && ewarn "Failed to load zoneinfo!"
961 1452
962 # Stop the server and cleanup 1453 # Stop the server and cleanup
1454 einfo "Stopping the server ..."
963 kill $(< "${pidfile}" ) 1455 kill $(< "${pidfile}" )
964 rm -f "${sqltmp}" 1456 rm -f "${sqltmp}"
965 einfo "Stopping the server ..."
966 wait %1 1457 wait %1
967 einfo "Done" 1458 einfo "Done"
968} 1459}
969 1460
1461# @FUNCTION: mysql_pkg_postrm
1462# @DESCRIPTION:
1463# Remove mysql symlinks.
970mysql_pkg_postrm() { 1464mysql_pkg_postrm() {
971 : # mysql_lib_symlinks "${D}" 1465 : # mysql_lib_symlinks "${D}"
972} 1466}

Legend:
Removed from v.1.118  
changed lines
  Added in v.1.163

  ViewVC Help
Powered by ViewVC 1.1.20